<?php
/*
Title: mapfiles.php

Funes utilizadas pelo editor dos mapfiles de inicializao

 utilizado nas funes em AJAX da interface de edio que permite alterar os mapfiles geral1.map ou geral1windows.map

O mapfile que deve ser editado  obtido por meio do programa <admin.php>

Licenca:

GPL2

i3Geo Interface Integrada de Ferramentas de Geoprocessamento para Internet

Direitos Autorais Reservados (c) 2006 Ministrio do Meio Ambiente Brasil
Desenvolvedor: Edmar Moretti edmar.moretti@mma.gov.br

Este programa  software livre; voc pode redistribu-lo
e/ou modific-lo sob os termos da Licena Pblica Geral
GNU conforme publicada pela Free Software Foundation;

Este programa  distribudo na expectativa de que seja til,
porm, SEM NENHUMA GARANTIA; nem mesmo a garantia implcita
de COMERCIABILIDADE OU ADEQUAO A UMA FINALIDADE ESPECFICA.
Consulte a Licena Pblica Geral do GNU para mais detalhes.
Voc deve ter recebido uma cpia da Licena Pblica Geral do
GNU junto com este programa; se no, escreva para a
Free Software Foundation, Inc., no endereo
59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

Arquivo:

i3geo/admin/php/mapfiles.php

Parametros:

O parmetro principal  "funcao", que define qual operao ser executada, por exemplo, mapfiles.php?funcao=PEGAPARAMETROSCONFIGURA

Cada operao possu seus prprios parmetros, que devem ser enviados tambm na requisio da operao.

*/
require_once("admin.php");
//faz a busca da funo que deve ser executada
switch (strtoupper($funcao))
{
	/*
	Note:
	
	Valores que o parmetro &funcao pode receber. Os parmetros devem ser enviados na requisio em AJAX.
	*/
	/*
	Valor: PEGAPARAMETROSCONFIGURA
	
	Pega os parmetros principais de configurao do mapfile
		
	Retorno:
	
	{JSON}
	*/
	case "PEGAPARAMETROSCONFIGURA":
		$vs = array(
			"FONTSET ",
			"SYMBOLSET ",
			"SHAPEPATH ",
			"EXTENT ",
			"IMAGE ",
			"IMAGEPATH ",
			"IMAGEURL "
		);
		$par = array();
		foreach ($vs as $v)
		{
			$handle = fopen ($locaplic."/aplicmap/".$mapfile.".map", "r");
			while (!feof ($handle)) {
				$buffer = fgets($handle);
				if(!(stristr($buffer, $v) === FALSE))
				{
					$temp = explode(trim($v),$buffer);
					if(trim($temp[0]) != "#")
					{
						$temp = trim($temp[1]);
						$par[trim($v)] = $temp;
						fclose ($handle);
						break;
					}
				}    		
			}
		}
		retornaJSON($par);
		exit;
	break;
	//depreciado
	case "RESTAURACONFIGURA":
		if(verificaEditores($editores) == "nao")
		{echo "Vc nao e um editor cadastrado. Apenas os editores definidos em i3geo/ms_configura.php podem acessar o sistema de administracao.";exit;}
		$cp->register('restauraConfigura');
		unlink($locaplic."/aplicmap/".$mapfile.".map");
		copy ($locaplic."/aplicmap/".$mapfile.".default",$locaplic."/aplicmap/".$mapfile.".map");
		$cp->set_data("ok");
		$cp->return_data();
	break;
	/*
	Valor: SALVACONFIGURA
	
	Salva o valor de um parmetro no mapfile em edio
	
	Parametros:
	
	variavel
	
	valor
		
	Retorno:
	
	{JSON}
	*/
	case "SALVACONFIGURA":
		if(verificaEditores($editores) == "nao")
		{echo "Vc nao e um editor cadastrado. Apenas os editores definidos em i3geo/ms_configura.php podem acessar o sistema de administracao.";exit;}
		salvaConfigura($variavel,$valor,$mapfile,$locaplic);
		retornaJSON("ok");
		exit;
	break;
}
/*
Salva um novo valor de uma varivel no ms_configura.php
*/
function salvaConfigura($variavel,$valor,$mapfile,$locaplic)
{
	$handle = fopen ($locaplic."/aplicmap/".$mapfile.".map", "r");
	$linhas = array();
	$valor = str_replace("\\\"",'"',$valor);
	while (!feof ($handle)) {

    	$buffer = fgets($handle);
		if(!(stristr($buffer, $variavel) === FALSE))
		{
    		$temp = explode(trim($variavel),$buffer);
    		if(trim($temp[0]) != "#")
    		{
    			$temp = trim($temp[1]);
    			$par[trim($variavel)] = $temp;
    			$linhas[] = $variavel." ".$valor."\n";
    			$variavel = "______________";
    		}
    		else{$linhas[] = $buffer;}
  		}    		
		else
		$linhas[] = $buffer;
	}
	fclose ($handle);
	unlink($locaplic."/aplicmap/".$mapfile.".map");
	$handle = fopen ($locaplic."/aplicmap/".$mapfile.".map", "w");
	foreach ($linhas as $linha)
	{
		fwrite($handle, $linha);
	}
	fclose($handle);
}

?>